# Analysis Tools for Belle and Belle II Analyses with basf2

This package contains many convenience functions which solve problems that appear in most analyses
at some point. The package was originally developed for the analysis of $`B \rightarrow D^{(*)} \tau \nu`$
decays with B2BII converted Belle data, but is kept general enough to provide a solid base for most
other basf2 analyses.

If you are missing some needed functionality, feel free to contribute,
so that others can also profit from the effort you put in.

## Installation

First make sure to install the necessary python packages on top of your basf2 externals via

```shell
pip3 install --upgrade pip
pip3 install -r requirements.txt
```

after setting up your local basf2 environment.

To install this package use

```shell
pip3 install <path/to/directory/containing/this/README>
```

or the command with the `--editable` option to allow for continuous development:

```shell
pip3 install -e <path/to/directory/containing/this/README>
```

If you are using a basf2 release, or an externals version to which you do not have write access,
you can install the package locally via

```shell
pip3 install --user -r requirements.txt
pip3 install --user <path/to/directory/containing/this/README>
```

## Development

For development, please consider to also add the required package
[`TemplateFitter`](https://github.com/FelixMetzner/TemplateFitter)
manually via the instructions given in its `README`
instead of installing it via the `-r` option of `pip3 install`.

### Pre-Commit Hooks

If you want to contribute to this package,
please consider using the pre-commit hooks
which can be installed by running the following commands:
```shell
pip3 install pre-commit
pre-commit install
```
