def getPIDCorrection(choice=0):
    
    with open('../../8_Systematics/PID_dump_sig.txt', 'r+') as f:
        data = f.read()
        valK = np.array(re.findall('ratio  ([0-9.]+) \+- [0-9.]+ \(', data),dtype=float)
        eK = np.array(re.findall('systematic error \(i.e. ([0-9.]+) syst. error\)',data),dtype=float)
        valEl = np.array(re.findall('EIDCORR: Corr  ([0-9.]+) \+- ([0-9.]+)',data),dtype=float)
        valMu = np.array(re.findall('MUIDCORR: Corr  ([0-9.]+) \+- ([0-9.]+)',data),dtype=float)
        nEl = np.array(re.findall('# electrons: ([0-9]+)',data),dtype=int)[0]
        nMu = np.array(re.findall('# muons: ([0-9]+)',data),dtype=int)[0]

    K0_S1 = [valK[0],eK[0]]
    K1_S1 = [valK[1],eK[1]]
    K0_S2 = [valK[2],eK[2]]
    K1_S2 = [valK[3],eK[3]]

    e_S1 = [valEl[0][0],valEl[0][1]]
    e_S2 = [valEl[1][0],valEl[1][1]]

    mu_P1 = [valMu[0][0],valMu[0][1]]
    mu_P2 = [valMu[1][0],valMu[1][1]]
    mu_P3 = [valMu[2][0],valMu[2][1]]
    mu_P4 = [valMu[3][0],valMu[3][1]]

    P1 = 140.909
    P2 = 159.856
    P3 = 187.850
    P4 = 216.877

    S1 = P1
    S2 = P2+P3+P4

    weights1 = [S1,S2]
    weights2 = [P1,P2,P3,P4]

    def avg(weights,vals):
        weights = np.array(weights)
        vals = np.array(vals)
        return sum(weights * vals)/sum(weights)

    def err(weights,errors,corr=0):
        weights = np.array(weights)
        errors = np.array(errors)
        val = 0
        for i in range(len(weights)):
            for j in range(len(weights)):
                if i==j:
                    val += weights[i]*weights[j]*errors[i]*errors[j]
                else:
                    val += weights[i]*weights[j]*errors[i]*errors[j]*corr
                    
        return np.sqrt(val)/sum(weights)

    K0 = [avg(weights1,[K0_S1[0],K0_S2[0]]),err(weights1,[K0_S1[1],K0_S2[1]],corr=1)]
    K1 = [avg(weights1,[K1_S1[0],K1_S2[0]]),err(weights1,[K1_S1[1],K1_S2[1]],corr=1)]

    e = [avg(weights1,[e_S1[0],e_S2[0]]),err(weights1,[e_S1[1],e_S2[1]],corr=1)]
    mu = [avg(weights2,[mu_P1[0],mu_P2[0],mu_P3[0],mu_P4[0]]),err(weights2,[mu_P1[1],mu_P2[1],mu_P3[1],mu_P4[1]],corr=1)]

    n_e = nEl
    n_mu = nMu
    lep = [avg([n_e,n_mu],[e[0],mu[0]]),err([n_e,n_mu],[e[1],mu[1]],corr=0)]


    sigma_K2  = (K1[0]*K0[1])**2 
    sigma_K2 += (K0[0]*K1[1])**2
    sigma_K2 += 2*K1[0]*K0[0]*K0[1]*K1[1]*1.00

    K = [K0[0]*K1[0],np.sqrt(sigma_K2)]

    def proderr(vals,errs):
        vals = np.array(vals)
        errs = np.array(errs)
        return np.sqrt((vals[1]*errs[0])**2 + (vals[0]*errs[1])**2)

    PID = [K[0]*lep[0],proderr([K[0],lep[0]],[K[1],lep[1]])]

    PID_e = [K[0]*e[0],proderr([K[0],e[0]],[K[1],e[1]])]
    PID_mu = [K[0]*mu[0],proderr([K[0],mu[0]],[K[1],mu[1]])]
    
    if choice == 0:
        return PID
    elif choice == 1:
        return PID_e
    elif choice == 2:
        return PID_mu   
    


