#include <algorithm> 
#include <vector>
#include "TMath.h"
#include "TVectorD.h"
#include "TMatrixD.h"
#include "TRandom.h"

void generateVariatedWeights(){ // for ElID-cut = 0.5 & MuID-cut = 0.9

  int nbToys = 20;
  int nbLines = 70;
  TRandom *rand = new TRandom(3762);
    

  // Electrons
  //--------------------------------------------------------------------------------------------
  std::vector<TString> inFiles_el = {"LepEff_el_SVD1.txt", "LepEff_el_SVD2.txt"};

  std::ofstream outputData("LepEff_table_el.txt", std::ofstream::binary);

  for(int file=0; file<inFiles_el.size(); file++){

    float Corrections[nbLines][9];
    std::ifstream inputData(inFiles_el.at(file), std::ifstream::in);

    for(int line=0; line<nbLines; line++){
      for(int column=0; column<9; column++){
	inputData >> Corrections[line][column];
      }
    }

    inputData.close();
      
    for(int line=0; line<nbLines; line++){
      // first columns: technical details
      if(file==0) outputData << 0 << " " << 27 << " "; // SVD1
      else outputData << 28 << " " << 100 << " "; // SVD2
      for(int column=1; column<9; column++){
	outputData << Corrections[line][column] << " ";
      }
      // // Toy weights
      // float err = pow(Corrections[line][6],2) +  pow(Corrections[line][7],2) +  pow(Corrections[line][8],2);
      // for(int k=0; k<nbToys; k++) outputData << rand->Gaus(Corrections[line][5],err) << " ";
      outputData << std::endl;
    }

  }

  outputData.close();


  // Muons
  //--------------------------------------------------------------------------------------------
  std::vector<TString> inFiles_mu = {"LepEff_mu_SVD1.txt", "LepEff_mu_31.txt", "LepEff_mu_41.txt", "LepEff_mu_51.txt"};

  std::ofstream outputData2("LepEff_table_mu.txt", std::ofstream::binary);

  for(int file=0; file<inFiles_mu.size(); file++){

    float Corrections[nbLines][9];
    std::ifstream inputData(inFiles_mu.at(file), std::ifstream::in);

    for(int line=0; line<nbLines; line++){
      for(int column=0; column<9; column++){
	inputData >> Corrections[line][column];
      }
    }

    inputData.close();
      
    for(int line=0; line<nbLines; line++){
      // first columns: technical details
      if(file==0) outputData2 << 0 << " " << 27 << " "; // SVD1
      else if(file==1) outputData2 << 28 << " " << 39 << " "; 
      else if(file==2) outputData2 << 40 << " " << 49 << " "; 
      else outputData2 << 50 << " " << 100 << " "; 
      for(int column=1; column<9; column++){
	outputData2 << Corrections[line][column] << " ";
      }
      // // Toy weights
      // float err = pow(Corrections[line][6],2) +  pow(Corrections[line][7],2) +  pow(Corrections[line][8],2);
      // for(int k=0; k<nbToys; k++) outputData2 << rand->Gaus(Corrections[line][5],err) << " ";
      outputData2 << std::endl;
    }

  }

  outputData.close();


}
