from setuptools import setup, find_packages

setup(
    name="AnalysisTools",
    version="0.2.0",
    packages=find_packages(),
    url="https://gitlab.ekp.kit.edu/fmetzner/AnalysisTools",
    license="",
    author="Felix Metzner",
    author_email="felix.metzner@kit.edu",
    description="General analysis tools for analyses of Belle and Belle II data with basf2.",
    entry_points={
        "console_scripts": [
            "root2hdf=analysistools.dataframe_tools.cmd_line:root2hdf",
            "nevents_in_filedict=analysistools.batch_tools.file_handler:nevents_in_filedict",
            "nevents_in_all_signal_filedicts=analysistools.batch_tools.file_handler:nevents_in_all_signal_filedicts",
        ]
    },
    package_data={
        "pid_corrections": ["*tables/*.csv", "*tables/*.dat"],
        "k_short_correction": ["*.csv"],
        "tracking_correction": ["*.csv"],
    },
)
