"""
This module contains unit tests for function and classes defined in
analysistools.dataframe_tools.dataframe_tools.

Max Welsch 2018
"""
import unittest
import numpy as np
import pandas as pd

from analysistools.dataframe_tools.dataframe_tools import apply_cut


class TestApplyCuts(unittest.TestCase):
    def setUp(self):
        self.df1 = pd.DataFrame(
            {
                "x": np.array([-1, -1, 1, 1]),
                "y": np.array([1, 1, 3, 4]),
            }
        )

    def test_apply_cut(self):
        new_data, stats = apply_cut(self.df1, "x < 0 and y < 2")
        self.assertEqual(2, len(new_data.index))
        print(stats)
